/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the PostMeEntrypointsRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PostMeEntrypointsRequest{}

// PostMeEntrypointsRequest struct for PostMeEntrypointsRequest
type PostMeEntrypointsRequest struct {
	Purpose *string `json:"purpose,omitempty"`
}

// NewPostMeEntrypointsRequest instantiates a new PostMeEntrypointsRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPostMeEntrypointsRequest() *PostMeEntrypointsRequest {
	this := PostMeEntrypointsRequest{}
	return &this
}

// NewPostMeEntrypointsRequestWithDefaults instantiates a new PostMeEntrypointsRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPostMeEntrypointsRequestWithDefaults() *PostMeEntrypointsRequest {
	this := PostMeEntrypointsRequest{}
	return &this
}

// GetPurpose returns the Purpose field value if set, zero value otherwise.
func (o *PostMeEntrypointsRequest) GetPurpose() string {
	if o == nil || IsNil(o.Purpose) {
		var ret string
		return ret
	}
	return *o.Purpose
}

// GetPurposeOk returns a tuple with the Purpose field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostMeEntrypointsRequest) GetPurposeOk() (*string, bool) {
	if o == nil || IsNil(o.Purpose) {
		return nil, false
	}
	return o.Purpose, true
}

// HasPurpose returns a boolean if a field has been set.
func (o *PostMeEntrypointsRequest) HasPurpose() bool {
	if o != nil && !IsNil(o.Purpose) {
		return true
	}

	return false
}

// SetPurpose gets a reference to the given string and assigns it to the Purpose field.
func (o *PostMeEntrypointsRequest) SetPurpose(v string) {
	o.Purpose = &v
}

func (o PostMeEntrypointsRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PostMeEntrypointsRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Purpose) {
		toSerialize["purpose"] = o.Purpose
	}
	return toSerialize, nil
}

type NullablePostMeEntrypointsRequest struct {
	value *PostMeEntrypointsRequest
	isSet bool
}

func (v NullablePostMeEntrypointsRequest) Get() *PostMeEntrypointsRequest {
	return v.value
}

func (v *NullablePostMeEntrypointsRequest) Set(val *PostMeEntrypointsRequest) {
	v.value = val
	v.isSet = true
}

func (v NullablePostMeEntrypointsRequest) IsSet() bool {
	return v.isSet
}

func (v *NullablePostMeEntrypointsRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePostMeEntrypointsRequest(val *PostMeEntrypointsRequest) *NullablePostMeEntrypointsRequest {
	return &NullablePostMeEntrypointsRequest{value: val, isSet: true}
}

func (v NullablePostMeEntrypointsRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePostMeEntrypointsRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


